@use 'sass:map';
@use '@angular/material'as mat;
@use '../palette';

// component mixins
@use 'header-theme'as header;
@use 'footer-theme'as footer;
@use 'search-filter-theme'as toolbar;
@use 'standard-hover'as hover;
@use 'standard-selected'as selected;
@use 'card';
@use 'contact-background'as contact;
@use 'side-menu'as side-menu;
@use 'table_theme'as table;
@use 'dialog-theme'as dialog;
@use 'drop-zone';
@use 'status';
@use 'clearance-table-theme' as clearance-table;
@use 'logo';


/*
  use this mixin to get colors from the currently set theme palette.
  pass the colors or palettes to component specific mixins.

  the same structure should be used if this is needed for typography or density styles

  best docs for available variables are the frameworks scss files found here:
  https://github.com/angular/components/tree/main/src/material/core
  a good starting point is:
  https://github.com/angular/components/blob/main/src/material/core/theming/_theming.scss
*/

@mixin set-colors($theme) {
  // config
  $config: mat.get-color-config($theme);
  // palette colors
  $primary-palette: map.get($config, 'primary');
  $accent-palette: map.get($config, 'accent');
  $warn-palette: map.get($config, 'warn');

  // palette background
  $foreground-palette: map-get($config, foreground);
  $background-palette: map-get($config, background);

  // is dark - boolean
  $is-dark-theme: map.get($config, 'is-dark');

  // @debug " $is dark: #{$is-dark-theme}";

  // primary colors -  read the hues from the primary color palette.
  $primary-color: mat.get-color-from-palette($primary-palette); // default should be 500
  $primary-color-50: mat.get-color-from-palette($primary-palette, 50);
  $primary-color-100: mat.get-color-from-palette($primary-palette, 100);
  $primary-color-200: mat.get-color-from-palette($primary-palette, 200);
  $primary-color-300: mat.get-color-from-palette($primary-palette, 300);
  $primary-color-400: mat.get-color-from-palette($primary-palette, 400);
  $primary-color-500: mat.get-color-from-palette($primary-palette, 500);
  $primary-color-600: mat.get-color-from-palette($primary-palette, 600);
  $primary-color-700: mat.get-color-from-palette($primary-palette, 700);
  $primary-color-800: mat.get-color-from-palette($primary-palette, 800);
  $primary-color-900: mat.get-color-from-palette($primary-palette, 900);


  // accent colors
  $accent-color-900: mat.get-color-from-palette($accent-palette, 900);

  // warn colors
  $warn-color-50: mat.get-color-from-palette($warn-palette, 50);
  $warn-color-300: mat.get-color-from-palette($warn-palette, 300);
  $warn-color-500: mat.get-color-from-palette($warn-palette, 500);

  // text-color
  $text-color: mat.get-color-from-palette($foreground-palette, text);
  $background-color: mat.get-color-from-palette($background-palette, background);

  $divider-color: mat.get-color-from-palette($foreground-palette, divider);
  $disabled-text-color: mat.get-color-from-palette($foreground-palette, disabled-text);

  // text-contrast color to primary background

  $text-color-primary-contrast: mat.get-color-from-palette($primary-palette, 500-contrast);
  $text-color-primary-50-contrast: mat.get-color-from-palette($primary-palette, 50-contrast);
  $text-color-primary-100-contrast: mat.get-color-from-palette($primary-palette, 100-contrast);
  $text-color-primary-200-contrast: mat.get-color-from-palette($primary-palette, 200-contrast);
  $text-color-primary-400-contrast: mat.get-color-from-palette($primary-palette, 400-contrast);

  //$text-color-primary-contrast: mat.get-contrast-color-from-palette($primary-palette, 500); //'default' as property does NOT work - 500 should be default value
  // $text-color-primary-50-contrast: mat.get-contrast-color-from-palette($primary-palette, 50);
  // $text-color-primary-100-contrast: mat.get-contrast-color-from-palette($primary-palette, 100);
  // $text-color-primary-400-contrast: mat.get-contrast-color-from-palette($primary-palette, 400);

  // @debug " $text-color-primary-contrast: #{$text-color-primary-contrast}";

  // dark grey colors
  $dark-gray-color-100: mat.get-color-from-palette(palette.$emp-dark-gray, 100);
  $dark-gray-color-300: mat.get-color-from-palette(palette.$emp-dark-gray, 300);

  // components specific mixins
  @include header.header-nav-link-color($primary-color, $text-color);
  // @include header.header-background-color($background-color);
  @include footer.footer-color($primary-color, $text-color-primary-400-contrast, $background-color);

  // toolbar used on marketplace filter and org search
  @include toolbar.search-filter-color(if($is-dark-theme, $primary-color-500, $primary-color-50),
    if($is-dark-theme, $text-color-primary-contrast, $text-color-primary-50-contrast));

  @include hover.hover-color($primary-color, $text-color-primary-contrast);
  @include selected.selected-color($primary-color-300, $text-color-primary-contrast);

  @include contact.contact-background-color($primary-color-400,
    $text-color-primary-400-contrast);

  @include side-menu.side-menu-color($primary-color-100, $text-color-primary-100-contrast);

  @include table.active-row-color(if($is-dark-theme, $primary-color-500, $primary-color-100),
    if($is-dark-theme, $text-color-primary-contrast, $text-color-primary-100-contrast));

  @include dialog.dialog-color($primary-color-400, $text-color-primary-400-contrast);
  @include dialog.set-normal-text-color($text-color);

  @include drop-zone.highlight-color($primary-color-50);
  @include drop-zone.error-color($warn-color-50);

  // organization status colors
  @include status.set-organization-active($accent-color-900);
  @include status.set-organization-inactive($dark-gray-color-300);
  @include status.set-organization-requires-activation($warn-color-500);
  @include status.set-organization-awaiting-activation($warn-color-300);
  @include status.set-organization-awaiting-deactivation($dark-gray-color-100);

  // user account status colors
  @include status.set-user-account-disabled($dark-gray-color-100);
  @include status.set-user-account-enable($accent-color-900);
  @include status.set-user-account-requires-verification($warn-color-500);
  @include status.set-user-account-needs-update($warn-color-300);

  @if not $is-dark-theme {
    @include clearance-table.table-row-colors($primary-color-50,$primary-color-100,$primary-color-200)
  }

  @include clearance-table.table-header-color($disabled-text-color);
  @include clearance-table.table-border-color($divider-color);

  @include logo.set-logo-container($text-color-primary-400-contrast, $primary-color-50);
}
